import java.sql.*;
import java.util.Vector;

public class DatabaseConnection {
  private Connection connection;

    public DatabaseConnection(String db_file_name_prefix, String pw, String user, String dbURL, String forname) throws Exception{    // note more general exception

        Class.forName(forname);
        connection = DriverManager.getConnection(dbURL+db_file_name_prefix,   // filenames
                                           user,                    // username
                                           pw);                     // password
    }

    public void shutdown() throws SQLException {
        connection.close();
    }

    public synchronized Vector query(String expression) throws SQLException {
        Vector ret = new Vector();
        Statement st = null;
        ResultSet rs = null;
        st = connection.createStatement();
        rs = st.executeQuery(expression);
        ResultSetMetaData rsmd = rs.getMetaData();
        int columns = rsmd.getColumnCount();
        String col[] = new String[columns];
        for(int c = 0; c<columns; c++){
          col[c] = rsmd.getColumnName(c+1);
        }
        if(rs.next()){
          ret.addElement(col);
          do{
            Object obj[] = new Object[columns];
            for(int i=0; i<obj.length;i++){
              obj[i]=rs.getObject(i+1);
//              System.out.println("ret:"+obj[i].toString());
            }
            ret.addElement(obj);
          }while(rs.next());
        }else{
//          System.out.println("ret:nothing");
          ret = null;
        }
        st.close();
        return ret;
    }



    public Connection getConnection(){
      return connection;
    }
}